Index: /pjproject/main/pjsip/src/pjsip/sip_transport.c
===================================================================
--- /pjproject/main/pjsip/src/pjsip/sip_transport.c	(revision 42)
+++ /pjproject/main/pjsip/src/pjsip/sip_transport.c	(revision 43)
@@ -1358,6 +1419,5 @@
 		src_addr, src_port));
 
-	msg = pjsip_parse_msg( rdata->pool, rdata->packet, msg_fragment_size, 
-			       &rdata->parse_err);
+	msg = pjsip_parse_rdata( rdata->packet, msg_fragment_size, rdata);
 	if (msg == NULL) {
 	    PJ_LOG(3,(tr->obj_name, "Bad message (%d bytes from %s:%d)", msg_fragment_size,
@@ -1366,18 +1426,7 @@
 	}
 
-	/* Attach newly created message to rdata. */
-	rdata->msg = msg;
-
-	/* Extract Call-ID, From and To header and tags, topmost Via, and CSeq
-	* header from the message.
-	*/
-	call_id = pjsip_msg_find_hdr( msg, PJSIP_H_CALL_ID, NULL);
-	rdata->from = pjsip_msg_find_hdr( msg, PJSIP_H_FROM, NULL);
-	rdata->to = pjsip_msg_find_hdr( msg, PJSIP_H_TO, NULL);
-	rdata->via = pjsip_msg_find_hdr( msg, PJSIP_H_VIA, NULL);
-	rdata->cseq = pjsip_msg_find_hdr( msg, PJSIP_H_CSEQ, NULL);
-
-	if (call_id == NULL || rdata->from == NULL || rdata->to == NULL ||
-	    rdata->via == NULL || rdata->cseq == NULL) 
+	/* Perform basic header checking. */
+	if (rdata->call_id.ptr == NULL || rdata->from == NULL || 
+	    rdata->to == NULL || rdata->via == NULL || rdata->cseq == NULL) 
 	{
 	    PJ_LOG(3,(tr->obj_name, "Bad message from %s:%d: missing some header", 
@@ -1385,7 +1434,4 @@
 	    goto finish_process_fragment;
 	}
-	rdata->call_id = call_id->id;
-	rdata->from_tag = rdata->from->tag;
-	rdata->to_tag = rdata->to->tag;
 
 	/* If message is received from address that's different from the sent-by,
@@ -1402,5 +1448,5 @@
 	 */
 	if (rdata->via->rport_param == 0) {
-	    rdata->via->rport_param = pj_sockaddr_get_port(&rdata->addr);
+	    rdata->via->rport_param = pj_sockaddr_in_get_port(&rdata->addr);
 	}
 
@@ -1409,5 +1455,5 @@
 	if (msg->type == PJSIP_RESPONSE_MSG) {
 	    hdr = (pjsip_hdr*)rdata->via->next;
-	    if (hdr) {
+	    if (hdr != &rdata->msg->hdr) {
 		hdr = pjsip_msg_find_hdr(msg, PJSIP_H_VIA, hdr);
 		if (hdr) {
@@ -1446,7 +1492,9 @@
     rdata->addr_len = sizeof(rdata->addr);
     if (tr->type == PJSIP_TRANSPORT_UDP) {
-	pj_ioqueue_recvfrom( tr->mgr->ioqueue, tr->key,
-			    tr->rdata->packet, PJSIP_MAX_PKT_LEN,
+	pj_ssize_t size = PJSIP_MAX_PKT_LEN;
+	pj_ioqueue_recvfrom(tr->key, &tr->rdata->op_key,
+			    tr->rdata->packet, &size, 0, 
 			    &rdata->addr, &rdata->addr_len);
+	PJ_TODO(HANDLE_IMMEDIATE_DATA);
     }
 
@@ -1457,7 +1505,9 @@
 tcp_read_packet:
     if (tr->type == PJSIP_TRANSPORT_TCP) {
-	pj_ioqueue_read( tr->mgr->ioqueue, tr->key, 
+	pj_ssize_t size = PJSIP_MAX_PKT_LEN - tr->rdata->len;
+	pj_ioqueue_recv( tr->key, &tr->rdata->op_key,
 			 tr->rdata->packet + tr->rdata->len,
-			 PJSIP_MAX_PKT_LEN - tr->rdata->len);
+			 &size, 0);
+	PJ_TODO(HANDLE_IMMEDIATE_DATA_1);
     }
 #endif
@@ -1508,5 +1558,7 @@
 }
 
-static void on_ioqueue_read(pj_ioqueue_key_t *key, pj_ssize_t bytes_read)
+static void on_ioqueue_read(pj_ioqueue_key_t *key, 
+			    pj_ioqueue_op_key_t *op_key, 
+			    pj_ssize_t bytes_read)
 {
     pjsip_transport_t *t;
@@ -1516,8 +1568,10 @@
 }
 
-static void on_ioqueue_write(pj_ioqueue_key_t *key, pj_ssize_t bytes_sent)
-{
-    PJ_UNUSED_ARG(key)
-    PJ_UNUSED_ARG(bytes_sent)
+static void on_ioqueue_write(pj_ioqueue_key_t *key, 
+			     pj_ioqueue_op_key_t *op_key, 
+			     pj_ssize_t bytes_sent)
+{
+    PJ_UNUSED_ARG(key);
+    PJ_UNUSED_ARG(bytes_sent);
 
     /* Completion of write operation. 
@@ -1526,5 +1580,8 @@
 }
 
-static void on_ioqueue_accept(pj_ioqueue_key_t *key, int status)
+static void on_ioqueue_accept(pj_ioqueue_key_t *key, 
+			      pj_ioqueue_op_key_t *op_key, 
+			      pj_sock_t newsock,
+			      int status)
 {
 #if PJ_HAS_TCP
@@ -1534,6 +1591,6 @@
     handle_new_connection( t->mgr, t, status );
 #else
-    PJ_UNUSED_ARG(key)
-    PJ_UNUSED_ARG(status)
+    PJ_UNUSED_ARG(key);
+    PJ_UNUSED_ARG(status);
 #endif
 }
@@ -1547,6 +1604,6 @@
     handle_connect_completion( t->mgr, t, status);
 #else
-    PJ_UNUSED_ARG(key)
-    PJ_UNUSED_ARG(status)
+    PJ_UNUSED_ARG(key);
+    PJ_UNUSED_ARG(status);
 #endif
 }
Index: /pjproject/main/pjsip/src/pjsip/sip_uri.c
===================================================================
--- /pjproject/main/pjsip/src/pjsip/sip_uri.c	(revision 42)
+++ /pjproject/main/pjsip/src/pjsip/sip_uri.c	(revision 43)
@@ -1,10 +1,10 @@
 /* $Id$
- *
  */
 #include <pjsip/sip_uri.h>
 #include <pjsip/sip_msg.h>
-#include <pjsip/print.h>
+#include <pjsip/print_util.h>
 #include <pj/string.h>
 #include <pj/pool.h>
+#include <pj/assert.h>
 
 #define IS_SIPS(url)	((url)->vptr==&sips_url_vptr)
@@ -69,5 +69,5 @@
 static const pj_str_t *pjsip_url_get_scheme(const pjsip_url *url)
 {
-    PJ_UNUSED_ARG(url)
+    PJ_UNUSED_ARG(url);
     return &sip_str;
 }
@@ -75,5 +75,5 @@
 static const pj_str_t *pjsips_url_get_scheme(const pjsip_url *url)
 {
-    PJ_UNUSED_ARG(url)
+    PJ_UNUSED_ARG(url);
     return &sips_str;
 }
@@ -254,5 +254,5 @@
     }
 
-    if (strcmp(str_url1, str_url2)) {
+    if (pj_native_strcmp(str_url1, str_url2)) {
 	/* Not equal */
 	return -1;
Index: /pjproject/main/pjsip/src/pjsua/getopt.c
===================================================================
--- /pjproject/main/pjsip/src/pjsua/getopt.c	(revision 42)
+++ /pjproject/main/pjsip/src/pjsua/getopt.c	(revision 43)
@@ -279,5 +279,5 @@
    in GCC.  */
 #include <string.h>
-#define	my_index	strchr
+#define	my_index	pj_native_strchr
 #else
 
@@ -645,5 +645,5 @@
 	 then skip everything else like a non-option.  */
 
-      if (optind != argc && !strcmp (argv[optind], "--"))
+      if (optind != argc && !pj_native_strcmp(argv[optind], "--"))
 	{
 	  optind++;
Index: /pjproject/main/pjsip/src/pjsua/main.c
===================================================================
--- /pjproject/main/pjsip/src/pjsua/main.c	(revision 42)
+++ /pjproject/main/pjsip/src/pjsua/main.c	(revision 43)
@@ -251,5 +251,5 @@
     urllen = pjsip_uri_print(PJSIP_URI_IN_FROMTO_HDR, rdata->from->uri, url, sizeof(url)-1);
     if (urllen < 1) {
-	strcpy(url, "<unknown>");
+	pj_native_strcpy(url, "<unknown>");
     } else {
 	url[urllen] = '\0';
@@ -1104,5 +1104,5 @@
     
     if (global.user_id[0]=='\0') {
-	strcpy(global.user_id, "user");
+	pj_native_strcpy(global.user_id, "user");
     }
 
@@ -1234,10 +1234,10 @@
 			   rdata->from->uri, from, sizeof(from));
     if (len > 0) from[len] = '\0';
-    else strcpy(from, "<URL too long..>");
+    else pj_native_strcpy(from, "<URL too long..>");
 
     len = pjsip_uri_print( PJSIP_URI_IN_CONTACT_HDR, 
 			   rdata->to->uri, to, sizeof(to));
     if (len > 0) to[len] = '\0';
-    else strcpy(to, "<URL too long..>");
+    else pj_native_strcpy(to, "<URL too long..>");
 
     PJ_LOG(3,(THIS_FILE, "Incoming instant message:"));
Index: /pjproject/main/pjsip/src/pjsua/misc.c
===================================================================
--- /pjproject/main/pjsip/src/pjsua/misc.c	(revision 42)
+++ /pjproject/main/pjsip/src/pjsua/misc.c	(revision 43)
@@ -342,5 +342,5 @@
 	    break;
 	case OPT_USE_STUN1:   /* STUN server 1 */
-	    p = strchr(optarg, ':');
+	    p = pj_native_strchr(optarg, ':');
 	    if (p) {
 		*p = '\0';
@@ -357,5 +357,5 @@
 	    break;
 	case OPT_USE_STUN2:   /* STUN server 2 */
-	    p = strchr(optarg, ':');
+	    p = pj_native_strchr(optarg, ':');
 	    if (p) {
 		*p = '\0';
